//	DocTextCharStream.h
//	Copyright:	 1994 - 1998 by Apple Computer, Inc., all rights reserved.

#pragma once
#ifndef DocTextCharStream_h
#define DocTextCharStream_h

#pragma import on

#if PRAGMA_STRUCT_ALIGN
	#pragma options align=power
#endif

#include "IACharStream.h"
#include "IACorpus.h"

#pragma IA_BEGIN_EXPORTS

class DocTextCharStream : public IACharStream {
public:
				DocTextCharStream() : IACharStream(), docText(NULL) {}
				DocTextCharStream(IADocText* text) : IACharStream(), docText(text) {}
			 	~DocTextCharStream();

	uint32		GetNextBuffer(char* buffer, uint32 bufferLen);
	IADocText*	GetDocText() const {return docText;}
	
private:
	IADocText*		docText;
	
};

#pragma IA_END_EXPORTS

#if PRAGMA_STRUCT_ALIGN
	#pragma options align=reset
#endif

#pragma import reset

#endif
