//
//	File:		EnglishAnalysis.h
//	Copyright:	 1994 - 1998 by Apple Computer, Inc., all rights reserved.
//

#pragma once
#ifndef ENGLISHANALYSIS_h
#define ENGLISHANALYSIS_h

#pragma import on

#if PRAGMA_STRUCT_ALIGN
	#pragma options align=power
#endif

#include "IAAnalysis.h"

#pragma IA_BEGIN_EXPORTS

class LetterTree;
class StemmingDictionary;

const uint32		EnglishAnalysisType = 'Eng1';

class EnglishAnalysis : public IAAnalysis {
public:
					EnglishAnalysis(IADocText* stopwordDoc, IADocText* stemDictDoc);
					EnglishAnalysis(char* stopwordFilePath, char* stemDictFilePath);
					EnglishAnalysis() : IAAnalysis(EnglishAnalysisType),
										stopwordDB(NULL), stemDict(NULL) {}
	virtual			~EnglishAnalysis();

	IATokenStream*	MakeTokenStream(IADocText* text);
	IATerm*			GetProtoTerm();
private:
	LetterTree*			stopwordDB;
	StemmingDictionary*	stemDict;
};

#pragma IA_END_EXPORTS

#if PRAGMA_STRUCT_ALIGN
	#pragma options align=reset
#endif

#pragma import reset

#endif
