// InVecIndex.h
//	Copyright:	 1994 - 1998 by Apple Computer, Inc., all rights reserved.

// combines vector and inverted indices

#pragma once
#ifndef InVecIndex_h
#define InVecIndex_h

#pragma import on

#if PRAGMA_STRUCT_ALIGN
	#pragma options align=power
#endif

#include "VectorIndex.h"
#include "InvertedIndex.h"

#pragma IA_BEGIN_EXPORTS

const uint32		InVecIndexType = 'I&V2';

class InVecIndex : public InvertedIndex,  public VectorIndex {
public:
				InVecIndex(IAStorage* s, IACorpus* c, IAAnalysis* a, uint32 t = InVecIndexType, IABlockID r = NULL);
	IA_INLINE	~InVecIndex() IA_INLINE_DEF()	// no-op dtor def
					
	IADefineNarrowMethods(InVecIndex, IAIndex);
protected:
	void				DeletingDoc(DocInfo* i);
};

#pragma IA_END_EXPORTS

#if PRAGMA_STRUCT_ALIGN
	#pragma options align=reset
#endif

#pragma import reset

#endif
